package com.unipi.talepis;

public class ObjectInitialization {
    private static String message = giveMessageValue();
    private String name = giveNameValue();
    private static String giveMessageValue(){
        System.out.println("A static method executed");
        return "Hello Unipi!";
    }
    private String giveNameValue(){
        System.out.println("An instance method executed");
        return "Alexandros";
    }
    public ObjectInitialization() {
        System.out.println("Constructor executed");
    }
    static {
        System.out.println("Static initializer 1`called");
    }
    static {
        System.out.println("Static initializer 2`called");
    }
    {
        System.out.println("Instance initializer 1`called");
    }
    public static void main(String[] args) {
        new ObjectInitialization();
        //new ObjectInitialization();
        new ObjectInitialization(){};
    }
    {
        System.out.println("Instance initializer 2 called");
    }
}
